hdu 5587--Array

问题描述

Vicky是个热爱数学的魔法师,拥有复制创造的能力。
一开始他拥有一个数列{1}。每过一天,他将他当天的数列复制一遍,放在数列尾,并在两个数列间用0隔开。Vicky想做些改变,于是他将当天新产生的所有数字(包括0)全加1。Vicky现在想考考你,经过100天后,这个数列的前M项和是多少?。

输入描述

输入有多组数据。
第一行包含一个整数T,表示数据组数。T.(1≤T≤2∗10?^3??)
每组数据第一行包含一个整数M.(1≤M≤10^16??)

输出描述

对于每组数据输出一行答案.

输入样例

3
1
3
5

输出样例

1
4
7

Hint

第一项永远为数字11,因此样例1输出11
第二天先复制一次,用0隔开,得到{1,0,1},再把产生的数字加1,得到{1,1,2},因此样例2输出前3项和1+1+2=41+1+2=4.
第三天先得到{1,1,2,0,1,1,2},然后得到{1,1,2,1,2,2,3},因此样例3输出前5项和1+1+2+1+2=71+1+2+1+2=7

并不知道这题算什么题型。。。好题(我不会的都是好题,哼。。。

比赛时一直在找规律。。最后也没做出来。。。后来问了同学╭(╯^╰)╮

数组f[i]记录第i天一共有多少个数字,数组ans[i]第i天的数字和。注意到其实并不需要算到一百天。

/******************************************************
Problem : 5587 ( Array )     Judge Status : Accepted
RunId : 15697637    Language : G++    Author : G_lory
******************************************************/
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll f[100];
ll ans[100];

void init()
{
    f[1] = 1, ans[1] = 1;
    for (int i = 2; i <= 63; ++i) f[i] = f[i - 1] * 2 + 1;
    for (int i = 2; i <= 63; ++i) ans[i] = ans[i - 1] * 2 + 1 + f[i - 1];
}

ll dfs(ll x)
{
    if (x <= 1) return x;

    int pos = lower_bound(f + 1, f + 63, x) - f; // 计算需要多少天
    if (f[pos] == x) return ans[pos];
    return ans[pos - 1] + dfs(x - f[pos - 1] - 1) + x - f[pos - 1];
    // x - f[pos - 1] - 1 减去前一天的数字个数和零
}

int main()
{
    int t; ll n;
    cin >> t;
    init();
    while (t--)
    {
        cin >> n; cout << dfs(n) << endl;
    }
    return 0;
}

  

时间: 2024-10-08 17:31:59

hdu 5587--Array的相关文章

hdu 5587 Array 数学题

Array Time Limit: 20 Sec Memory Limit: 256 MB 题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=5587 Description Vicky is a magician who loves math. She has great power in copying and creating.One day she gets an array {1}. After that, every day she cop

HDU 5587——Array——————【规律】

Array Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 417    Accepted Submission(s): 211 Problem Description Vicky is a magician who loves math. She has great power in copying and creating.One

hdu 6197 array array array

http://acm.hdu.edu.cn/showproblem.php?pid=6197 题意:给你一个数组 然后给你一个k  让你从数组里面剔除k个数  使得剩余的数组 是 单调非递减  或 单调非递增的 判断可不可能 思路 : 直接写LIS  然后判断 n-k 和 LIS 长度的大小关系 #include<bits/stdc++.h> using namespace std; const int maxn = 1e5+100; const int INF = 0x3f3f3f3f; i

HDU 6197 array array array 2017沈阳网络赛 LIS

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6197 题意:给你n个数,问让你从中删掉k个数后(k<=n),是否能使剩下的序列为非递减或者非递增序列 解法:签到题,就是让你求最长不下降子序列长度len,然后判断下n-len是否小于k(将序列反着存下来然后再求即最长不上升子序列,取两者len中的较大值),然后直接套nlogn的模板即可. #include <bits/stdc++.h> using namespace std; const

HDU - 6197 array array array (最长上升子序列&amp;最长下降子序列)

题意:对于一个序列,要求去掉正好K个数字,若能使其成为不上升子序列或不下降子序列,则“A is a magic array.”,否则"A is not a magic array.\n". 分析: 1.求一遍LCS,然后在将序列逆转,求一遍LCS,分别可得最长上升子序列和最长下降子序列的长度tmp1.tmp2. 2.n - tmp1 <= k或n - tmp2 <= k即可,需要去掉的去完之后,在已经是最长上升或最长下降的序列中随便去够k个就好了. #include<

第十场 hdu 6172 Array Challenge(矩阵快速幂)

http://acm.hdu.edu.cn/showproblem.php?pid=6172 题目大意:按照给出的公式算出an 解题思路:an=4an-1+17an-2-12an-3,不要问我为什么,我也不知道(?_?) AC代码: 1 #include <iostream> 2 #include<bits/stdc++.h> 3 //if(~i)//当i不是-1时满足条件 4 using namespace std; 5 const int SMod=1e9+7; 6 struc

2017多校第10场 HDU 6172 Array Challenge 猜公式,矩阵幂

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6172 题意:如题. 解法: #include <bits/stdc++.h> using namespace std; typedef long long LL; const LL mod = 1e9+7; struct Matrix{ LL a[3][3]; void set1(){ memset(a, 0, sizeof(a)); } void set2(){ memset(a, 0, siz

hdu 6197 array array array LIS

正反跑一次LIS,取最大的长度,如果长度大于n-k就满足条件. ac代码: #include <cstdio> #include <cstring> #include <iostream> #include <queue> #include <map> #include <stack> #include <algorithm> using namespace std; int dp[1001]; int LIS(int a

HDU 6703 array(主席树)

http://acm.hdu.edu.cn/showproblem.php?pid=6703 题意 给定一个长度为n的排列(1-n),要你实现操作两种, 1 x:给第x个数加上1e7: 2 xy:查询最小的且不小于y的且不在区间[1,x]里出现过的数. 题解 对权值建主席树,维护区间最小值,插入一个数相当于这个数被ban,进行1操作相当于取消ban,如果真去实现修改会比较麻烦,由于这个序列是一个排列,我们对一些数取消ban相当于答案可以直接出现在这些数里,所以我们可以用set保存一下取消ban的

HDU - 6172:Array Challenge (BM线性递推)

题意:给出,三个函数,h,b,a,然后T次询问,每次给出n,求sqrt(an); 思路:不会推,但是感觉a应该是线性的,这个时候我们就可以用BM线性递推,自己求出前几项,然后放到模板里,就可以求了. 数据范围在1e15,1000组都可以秒过. 那么主要的问题就是得确保是线性的,而且得求出前几项. #include<bits/stdc++.h> using namespace std; #define rep(i,a,n) for (int i=a;i<n;i++) #define per